#define UNDERLIERS 5                                  /* Number of underliers */
#define TIMESLICES 4                                  /* Number of timeslices: 0 - TIMESLICES-1 */
#define POINTS 10                                     /* Number of points on last timeslice */
#define MINPOINTS 1                                   /* Number of points on timeslice 1 */
#define POWER 2.0                                     /* Power at which number of points grows with time */
#define PROBCUTOFF 0.01                               /* UNDERLIERS with less probability to become max will be ignored */
#define EXPIRATION 3.0                                /* Expiration date */
#define INTEREST 0.05*EXPIRATION/(TIMESLICES-1.0)     /* Interest rate per timeslice */
#define DIVIDEND 0.10*EXPIRATION/(TIMESLICES-1.0)     /* Dividend rate per timeslice */
#define VARIANCE 0.04*EXPIRATION/(TIMESLICES-1.0)     /* Variance per timeslice */
#define STRIKE 100.0                                  /* Strike price */
#define INITIAL 90.0                                  /* Initial price */


extern int  Max1[TIMESLICES][POINTS],                 /* Largest underlier price */
  Max2[TIMESLICES][POINTS];                           /* Second largest underlier price */
  

extern double Price[TIMESLICES][UNDERLIERS][POINTS],  /* Prices of underliers */
  Prob[TIMESLICES][UNDERLIERS][POINTS],               /* Probability of underlier becoming max */
  Value_if_exercised[TIMESLICES][POINTS],             /* Value of option if exercised at [t][p] */
  Value[TIMESLICES][POINTS],                          /* Value of option at [t][p] */
  Weight[POINTS],
  Cov[UNDERLIERS*UNDERLIERS],
  Parm[UNDERLIERS*(UNDERLIERS+3)/2+1],
  Scratch[UNDERLIERS],
  Sum_weights;


void weights1(int t1, int p1, int t2);
void weights2(int t1, int p1, int t2);
void init_rng(int t);
int points_on_timeslice(int t);
void generate_point(int t, int p);
void prob_of_max(int t, int p);
double mesh_estimate_3(int t, int p);
